﻿using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Calculations;
using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGWeightedSummaryCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {       
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();            
        }

        void SB_Click(object sender, RoutedEventArgs e)
        {
            Button b = sender as Button;
            Border border = Utilities.GetAncestorFromName(b, "border") as Border;
            SummaryCalculatorSelectionControl scsc = Utilities.GetDescendantFromType(border, typeof(SummaryCalculatorSelectionControl), false) as SummaryCalculatorSelectionControl;
            XamCheckEditor check = Utilities.GetDescendantFromName(scsc, "CustomSummaryCheckBox") as XamCheckEditor;
            XamComboEditor XCE = Utilities.GetDescendantFromName(scsc, "SummaryCombo") as XamComboEditor;

            if (XCE != null && check != null)
            {
                if (XCE.SelectedItem != null && check.IsChecked == true)
                {
                    Field weightedField = XCE.SelectedItem as Field;
                    Field summaryField = scsc.Field;

                    SummaryDefinition SD = new SummaryDefinition()
                    {
                        Key = "Weighted Sum",
                        Position = SummaryPosition.UseSummaryPositionField,
                        PositionFieldName = summaryField.Name
                    };

                    SummaryCalculationSettings calcSettings = new SummaryCalculationSettings()
                    {
                        Formula = "SUM([" + weightedField.CalculationSettings.ReferenceId + "],[" + summaryField.CalculationSettings.ReferenceId + "])"
                    };

                    SD.CalculationSettings = calcSettings;
                    summaryField.Owner.SummaryDefinitions.Add(SD);
                }
                else
                {
                    return;
                }
            }
        
        }      
    }
}
